unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    GroupBox3: TGroupBox;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    GroupBox4: TGroupBox;
    GroupBox5: TGroupBox;
    Button8: TButton;
    Button9: TButton;
    GroupBox6: TGroupBox;
    Button11: TButton;
    Button12: TButton;
    Memo1: TMemo;
    Button13: TButton;
    Button14: TButton;
    Button7: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
  private
    { Private declarations }
  public
    procedure mostrarPersonagens;
  end;

  TParsedString = record
    strings: array of string;
    count: integer;
  end;

  TPersonagem = record
     posicao: TPoint;
     nome: string[20];
     energia: integer;
  end;

const
     NOMEPADRAO = 'arquivo';

var
  Form1: TForm1;
  pers: array of TPersonagem;

implementation

{$R *.DFM}

//============================================================================================
//                                      Misc
//============================================================================================
//divide uma string em um array de strings, separados pelo "caract"
function ParseString(str, caract: string): TParsedString;
var
p1: integer;
begin
     result.count:= 0;
     while true do begin
          p1:= pos(caract, str);
          if (p1 = 0) or (p1 = -1) then break;
          setLength(result.strings, result.count + 1);
          result.strings[result.count]:= copy(str, 1, p1 -1);
          str:= copy(str, p1 + 1, length(str));
          result.count:= result.count + 1;
     end;
     if length(str) > 0 then begin
          setlength(result.strings, result.count + 1);
          result.strings[result.count]:= str;
          result.count:= result.count + 1;
     end;
end;

function lastWindowsErrorMsg: string;
var
error: cardinal;
nb: integer;
begin
     error:= GetLastError;
     setLength(result, 256);
     nb:= FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, nil, error, 0, PChar(result),
                        255, nil);
     result:= copy(result, 1, nb);
end;

procedure TForm1.mostrarPersonagens;
var
i: integer;
begin
     memo1.lines.clear;
     memo1.lines.add('Nmero de personagens: ' + intToStr(length(pers)));
     for i:= 0 to length(pers) -1 do with memo1.lines do begin
          add('====================');
          add('Posio: ' + intToStr(pers[i].posicao.x) + ' x ' + intToStr(pers[i].posicao.y));
          add('Nome: ' + pers[i].nome);
          add('Energia: ' + intToStr(pers[i].energia));
     end;
end;

//============================================================================================
//                                 Arquivos Binrios
//============================================================================================

procedure binCriarAPI(nomeDoArquivo: string);
type
     TCabecalho = record
          numPers: integer;
     end;
var
handle: cardinal;
cabe: TCabecalho;
tamEscrito: cardinal;
i: integer;
begin
     //abre o arquivo
     handle:= createFile(PChar(nomeDoArquivo), GENERIC_WRITE, 0, nil,
                         CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0);

     //se no existe...
     if handle = INVALID_HANDLE_VALUE then begin
          ShowMessage('Erro ao criar arquivo: ' + lastWindowsErrorMsg);
          exit;
     end else SetLastError(0); //resetar erro pq se o arquivo j existe o erro est definido

     //escreve o cabealho
     cabe.numPers:= length(pers);
     if not writeFile(handle, cabe, sizeof(TCabecalho), tamEscrito, nil) then begin
          showMessage('Erro ao escrever cabealho para arquivo: ' + lastWindowsErrorMsg);
          fileClose(handle);
          exit;
     end;

     //escreve os personagens
     for i:= 0 to cabe.numPers -1 do begin
          if not writeFile(handle, pers[i], sizeof(TPersonagem), tamEscrito, nil) then begin
               showMessage('Erro ao escrever personagem para arquivo: ' + lastWindowsErrorMsg);
               fileClose(handle);
               exit;
          end;
     end;

     //fecha o arquivo
     closeHandle(handle);
end;

procedure binLerAPI(nomeDoArquivo: string);
type
     TCabecalho = record
          numPers: integer;
     end;
var
handle: cardinal;
cabe: TCabecalho;
tamLido: cardinal;
i: integer;
begin
     //abre o arquivo
     handle:= createFile(PChar(nomeDoArquivo), GENERIC_READ, 0, nil,
                         OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);

     //se no existe...
     if handle = INVALID_HANDLE_VALUE then begin
          ShowMessage('Erro ao criar arquivo: ' + lastWindowsErrorMsg);
          exit;
     end else SetLastError(0); //resetar erro pq se o arquivo j existe o erro est definido

     //l o cabealho
     cabe.numPers:= length(pers);
     if not readFile(handle, cabe, sizeof(TCabecalho), tamLido, nil) then begin
          showMessage('Erro ao ler cabealho do arquivo: ' + lastWindowsErrorMsg);
          fileClose(handle);
          exit;
     end;

     //l os personagens
     setLength(pers, cabe.numPers);
     for i:= 0 to cabe.numPers -1 do begin
          if not readFile(handle, pers[i], sizeof(TPersonagem), tamLido, nil) then begin
               showMessage('Erro ao ler personagem do arquivo: ' + lastWindowsErrorMsg);
               fileClose(handle);
               exit;
          end;
     end;

     //fecha o arquivo
     closeHandle(handle);
end;

procedure binCriarPascal(nomeDoArquivo: string);
var
arq: file of TPersonagem;
i: integer;
begin
     //abre o arquivo
     AssignFile(arq, nomeDoArquivo);
     Rewrite(arq);

     //escrever personagens
     for i:= 0 to length(pers) -1 do
          write(arq, pers[i]);

     //fecha o arquivo
     CloseFile(arq);
end;

procedure binLerPascal(nomeDoArquivo: string);
var
arq: file of TPersonagem;
i: integer;
begin
     //abre o arquivo
     AssignFile(arq, nomeDoArquivo);
     reset(arq);

     //enquanto no for o fim do arquivo (EOF - end of file)
     i:= 0;
     while not eof(arq) do begin
          setLength(pers, i+1);
          read(arq, pers[i]);
          inc(i);
     end;

     //fecha o arquivo
     CloseFile(arq);
end;

procedure binCriarStream(nomeDoArquivo: string);
var
arq: TStream;
i: integer;
begin
     //abre arquivo
     arq:= TFileStream.create(nomeDoArquivo, fmCreate or fmShareExclusive);

     //escrever personagens
     for i:= 0 to Length(pers) -1 do
          arq.Write(pers[i], sizeof(TPersonagem));

     //fecha arquivo
     arq.free;
end;

procedure binLerStream(nomeDoArquivo: string);
var
arq: TStream;
i: integer;
begin
     //abre arquivo
     arq:= TFileStream.create(nomeDoArquivo, fmOpenRead or fmShareExclusive);

     //enquanto a posio do arquivo for menor que o seu tamanho
     i:= 0;
     while arq.Position < arq.Size do begin
          setLength(pers, i+1);
          arq.read(pers[i], sizeof(TPersonagem));
          inc(i);
     end;

     //fecha arquivo
     arq.free;
end;

//============================================================================================
//                                  Arquivos Texto
//============================================================================================
procedure txtCriarPascal(nomeDoArquivo: string);
var
arq: TextFile;
i: integer;
begin
     //abre o arquivo
     AssignFile(arq, nomeDoArquivo);
     Rewrite(arq);

     //escrever personagens
     for i:= 0 to Length(pers) -1 do with pers[i] do
          writeLn(arq, posicao.x, ':', posicao.y, ':', nome, ':', energia);

     //fecha o arquivo
     CloseFile(arq);
end;

procedure txtLerPascal(nomeDoArquivo: string);
var
arq: TextFile;
i: integer;
str: TParsedString;
s: string;
begin
     //abre o arquivo
     AssignFile(arq, nomeDoArquivo);
     reset(arq);

     //enquanto no for o fim do arquivo (EOF - end of file)
     i:= 0;
     while not eof(arq) do begin
          setLength(pers, i+1);
          //l uma linha
          Readln(arq, s);

          //quebra a linha nos dois pontos (:)
          str:= parseString(s, ':');
          with pers[i] do begin
               //pega cada item
               posicao.x:= strToInt(str.strings[0]);
               posicao.y:= strToInt(str.strings[1]);
               nome:= str.strings[2];
               energia:= strTOInt(str.strings[3]);
          end;
          inc(i);
     end;

     //fecha o arquivo
     CloseFile(arq);
end;

procedure txtCriarStringlist(NomeDoArquivo: string);
var
arq: TStrings;
i: integer;
begin
     //abre arquivo
     arq:= TStringList.Create;

     //escrever personagens
     for i:= 0 to Length(pers) -1 do with pers[i] do
          arq.Add(intToStr(posicao.x) + ':' + intToStr(posicao.y) + ':' +
                  nome + ':' + intToStr(energia));

     //fecha arquivo
     arq.SaveToFile(nomeDoArquivo);
     arq.free;
end;

procedure binLerStringlist(nomeDoArquivo: string);
var
arq: TStrings;
i: integer;
str: TParsedString;
begin
     //abre arquivo
     arq:= TStringList.create;
     arq.LoadFromFile(nomeDoArquivo);

     //enquanto existirem linhas para serem lidas
     i:= 0;
     while i < arq.count do begin
          setLength(pers, i+1);

          //quebra a linha entre os dois pontos (:)
          str:= parseString(arq[i], ':');
          with pers[i] do begin
          
               //pega os itens
               posicao.x:= strToInt(str.strings[0]);
               posicao.y:= strToInt(str.strings[1]);
               nome:= str.strings[2];
               energia:= strTOInt(str.strings[3]);
          end;
          inc(i);
     end;

     //fecha arquivo
     arq.free;
end;

procedure lerChunkRGB(str: TStream; size: integer);
begin
end;

procedure lerChunkBackgroundImg(str: TStream; size: integer);
begin
end;

procedure ler3ds(str: TStream);
var
wd: word;
size: integer;
begin
  str.read(wd, 2); //id do chunk principal
  str.read(size, 4); //tamanho do chunk principal
  //enquanto houverem dados a serem lidos
  while str.position < str.size do begin
    str.read(wd, 2);  //id desse chunk
    str.read(size, 4); //tamanho desse chunk
    if wd = $0010 then lerChunkRGB(str, size)
    else if wd = $1100 then lerChunkBackgroundImg(str, size)
    else str.position:= str.position + size;
  end;
end;

//============================================================================================
//                                      Form
//============================================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
     //cria alguns personagens
     SetLength(pers, 3);
     with pers[0] do begin
          posicao.x:= 10;
          posicao.y:= 20;
          nome:= 'Lobisomem';
          energia:= 100;
     end;
     with pers[1] do begin
          posicao.x:= 5;
          posicao.y:= 1;
          nome:= 'Fantasma';
          energia:= 150;
     end;
     with pers[2] do begin
          posicao.x:= 25;
          posicao.y:= 7;
          nome:= 'Curupira';
          energia:= 65;
     end;
     mostrarPersonagens;
end;

procedure TForm1.Button13Click(Sender: TObject);
begin
     SetLength(pers, 0);
     mostrarPersonagens;
end;

procedure TForm1.Button14Click(Sender: TObject);
begin
     mostrarPersonagens;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
     binCriarAPI(NOMEPADRAO + '.binapi');
end;


procedure TForm1.Button4Click(Sender: TObject);
begin
     binLerAPI(NOMEPADRAO + '.binapi');
     mostrarPersonagens;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
     binCriarPascal(NOMEPADRAO + '.binpascal');
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
     binLerPascal(NOMEPADRAO + '.binpascal');
     mostrarPersonagens;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
     binCriarStream(NOMEPADRAO + '.binstream');
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
     binLerStream(NOMEPADRAO + '.binstream');
     mostrarPersonagens;
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
     txtCriarPascal(NOMEPADRAO + '.txtpascal');
end;

procedure TForm1.Button11Click(Sender: TObject);
begin
     txtLerPascal(NOMEPADRAO + '.txtpascal');
     mostrarPersonagens;
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
     txtCriarStringlist(NOMEPADRAO + '.txtstringlist');
end;

procedure TForm1.Button12Click(Sender: TObject);
begin
     binLerStringlist(NOMEPADRAO + '.txtstringlist');
     mostrarPersonagens;
end;

procedure TForm1.Button7Click(Sender: TObject);
var
str: TmemoryStream;
begin
     str:= TmemoryStream.create;
     str.LoadFromFile('C:\delphi\glScene\Demos\media\beer.3ds');
     ler3ds(str);
     str.free;
end;

end.
